PB x86 compiler doesn't work anymore with newest Xcode!

Mac OSX specific forum
User avatar
Shardik
Addict
Addict
Posts: 1834
Joined: Thu Apr 21, 2005 2:38 pm
Location: Germany

PB x86 compiler doesn't work anymore with newest Xcode!

Post by Shardik »

PB 5.46 x86, PB 5.62 x86 and PB 5.70 x86 don't work anymore on MacOS 10.13.6 'High Sierra' with the most current Xcode 10.1 (10B61):
Image
When adding the following code at top of any PB code

Code: Select all

Import "-stdlib=libc++ -mmacosx-version-min=10.9" : EndImport
another window is displayed:
PureBasic - Linker error wrote:ld: warning: The i386 architecture is deprecated for macOS (remove from the Xcode build setting: ARCHS)
...
Apple seems to have removed the i386 architecture from its libraries beginning with Xcode 10.1, so it is now impossible to compile 32-bit programs (not only PB source codes) anymore. Therefore I didn't post this problem in "Bugs - Mac OSX" because it's not a PureBasic bug!
wilbert
PureBasic Expert
PureBasic Expert
Posts: 3734
Joined: Sun Aug 08, 2004 5:21 am
Location: Netherlands

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by wilbert »

You are right Shardik.

Personally I don't see any reason to continue to use PB x86 on MacOS but it is important to mention this.
macOS 10.15 Catalina, Windows 10
User avatar
Shardik
Addict
Addict
Posts: 1834
Joined: Thu Apr 21, 2005 2:38 pm
Location: Germany

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by Shardik »

Shardik wrote:Apple seems to have removed the i386 architecture from its libraries beginning with Xcode 10.1, so it is now impossible to compile 32-bit programs (not only PB source codes) anymore.
It's official:
Xcode 10 Release Notes wrote:The macOS 10.14 SDK no longer contains support for compiling 32-bit applications. If developers need to compile for i386, Xcode 9.4 or earlier is required.
So for compiling with PureBasic's x86 compiler you have to install Xcode 9.4 or earlier.
wilbert
PureBasic Expert
PureBasic Expert
Posts: 3734
Joined: Sun Aug 08, 2004 5:21 am
Location: Netherlands

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by wilbert »

Shardik wrote:So for compiling with PureBasic's x86 compiler you have to install Xcode 9.4 or earlier.
I think this will give a lot of confusion for new users.

You mentioned earlier that the minimum requirement for the latest version of PB is OSX 10.8 which only works on 64 bit hardware.
Maybe new PB x86 versions could be moved immediately to the museum section so people who need it can still download it but it is clear the preferred version is the x64 version ?
macOS 10.15 Catalina, Windows 10
Fred
Administrator
Administrator
Posts: 14325
Joined: Fri May 17, 2002 4:39 pm
Location: France
Contact:

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by Fred »

I think it's time to drop x86 support on OS X. I did the same on SpiderBasic, as it was displaying a warning on new OSX (32-bit application are deprectaed and won't be supported in future version)
User avatar
Shardik
Addict
Addict
Posts: 1834
Joined: Thu Apr 21, 2005 2:38 pm
Location: Germany

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by Shardik »

wilbert wrote:You mentioned earlier that the minimum requirement for the latest version of PB is OSX 10.8 which only works on 64 bit hardware.
That's incorrect.
[color=#0040FF][u]In Bugs - Documentation Shardik[/u][/color] wrote:The oldest MacOS version with PB 5.70 Beta 2 working on (both 32-bit and 64-bit compilers) is MacOS 10.8.5 'Mountain Lion'. Therefore the requirements on PureBasic's website should be adapted.
In summary the situation is very simple. Only on MacOS 10.13 'High Sierra' and MacOS 10.14 'Mojave' with Xcode 10 the PureBasic x86 compiler doesn't work anymore. In High Sierra and Mojave with Xcode 9.4 or older the PureBasic x86 compiler works like a charm. MacOS 10.12 'Sierra' and older versions aren't supported by Xcode 10. And the most recent Xcode 10.2 even doesn't support High Sierra anymore!
wilbert
PureBasic Expert
PureBasic Expert
Posts: 3734
Joined: Sun Aug 08, 2004 5:21 am
Location: Netherlands

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by wilbert »

Shardik wrote:That's incorrect.
I wasn't trying to say the x86 version wouldn't work.
What I was trying to say is that MacOS 10.8 requires a 64 bit cpu and therefore a 64 bit application should always work.
Looking at it from that point there is no strong reason anymore to compile a 32 bit application or maintain the x86 version of PB if MacOS 10.8 is the minimum requirement.
There can of course be other reasons why you would prefer to compile and run a 32 bit application like cross platform compatibility, less memory consumption or maintaining an old source.
Anyway, for me it would be no problem if x86 support for MacOS would be dropped.
macOS 10.15 Catalina, Windows 10
User avatar
Shardik
Addict
Addict
Posts: 1834
Joined: Thu Apr 21, 2005 2:38 pm
Location: Germany

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by Shardik »

wilbert wrote:What I was trying to say is that MacOS 10.8 requires a 64 bit cpu and therefore a 64 bit application should always work.
Looking at it from that point there is no strong reason anymore to compile a 32 bit application or maintain the x86 version of PB if MacOS 10.8 is the minimum requirement.
There can of course be other reasons why you would prefer to compile and run a 32 bit application like cross platform compatibility, less memory consumption or maintaining an old source.
I fully agree.
User avatar
Andre
PureBasic Team
PureBasic Team
Posts: 1877
Joined: Fri Apr 25, 2003 6:14 pm
Location: Germany (Saxony, Deutscheinsiedel)
Contact:

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by Andre »

Fred wrote:I think it's time to drop x86 support on OS X. I did the same on SpiderBasic, as it was displaying a warning on new OSX (32-bit application are deprectaed and won't be supported in future version)
Please not, at least for now... :D

If there isn't (much?) extra effort, the 32bit compilation is the only chance I have on my MacBook to use latest PB version.

I'm using MacOS El Capitan (10.11) on my MacBook and couldn't upgrade to a newer (x64) version, as the "Apple Hardware Check" says that my system of 2011 is too old.... which is still running fine (upgraded with SSD and more RAM).
Bye,
...André
(PureBasicTeam::Docs & Support - PureArea.net | Order:: PureBasic | PureVisionXP)
Fred
Administrator
Administrator
Posts: 14325
Joined: Fri May 17, 2002 4:39 pm
Location: France
Contact:

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by Fred »

OK, no problem. Will just put the 64-bit version behing in download
wilbert
PureBasic Expert
PureBasic Expert
Posts: 3734
Joined: Sun Aug 08, 2004 5:21 am
Location: Netherlands

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by wilbert »

Andre wrote:If there isn't (much?) extra effort, the 32bit compilation is the only chance I have on my MacBook to use latest PB version.

I'm using MacOS El Capitan (10.11) on my MacBook and couldn't upgrade to a newer (x64) version, as the "Apple Hardware Check" says that my system of 2011 is too old.... which is still running fine (upgraded with SSD and more RAM).
Do you mean you can't run the x64 versions of PureBasic on your MacBook ?
That would be strange since MacOS 10.11 requires a 64 bit cpu as far as I know :?
macOS 10.15 Catalina, Windows 10
User avatar
the.weavster
Addict
Addict
Posts: 1356
Joined: Thu Jul 03, 2003 6:53 pm
Location: England

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by the.weavster »

Rumour is Apple is planning to migrate to ARM.
User avatar
Andre
PureBasic Team
PureBasic Team
Posts: 1877
Joined: Fri Apr 25, 2003 6:14 pm
Location: Germany (Saxony, Deutscheinsiedel)
Contact:

Re: PB x86 compiler doesn't work anymore with newest Xcode!

Post by Andre »

wilbert wrote:Do you mean you can't run the x64 versions of PureBasic on your MacBook ?
That would be strange since MacOS 10.11 requires a 64 bit cpu as far as I know :?
Sorry for the late reply...

...after doing several tests yesterday I came to this mortifying :oops: conclusion:

PB5.70 as x64 version runs well on my MacBook :D

Beeing a long-time x86 user (Win98 - XP) using PB 32bit version, I just stayed with 32bit PB when I bought my MacBook back in 2011, and didn't upgrade to newer OS X versions for a long time. Don't know anymore, but over the time I just believed that I'm owning just only a x86 Mac.... :wink:

Now with MacOS X El Capitan (10.11.6) I have successfully installed PB5.70 as 64bit version. And also my big project compiles/runs fine, just like it does on my Win10 laptop :D

So for my own use the support of the OS X x64 version would be enough, I'm just thinking if we should still be able to compile 32bit OS X application if needed!?
Bye,
...André
(PureBasicTeam::Docs & Support - PureArea.net | Order:: PureBasic | PureVisionXP)
Post Reply